hdu 4941 Magical Forest(STL之map应用)2014多校训练第7场

Magical Forest

                                                                      Time Limit: 24000/12000 MS (Java/Others)    Memory Limit:
131072/131072 K (Java/Others)

Problem Description

There is a forest can be seen as N * M grid. In this forest, there is some magical fruits, These fruits can provide a lot of energy, Each fruit has its location(Xi, Yi) and the energy can be provided Ci.

However, the forest will make the following change sometimes:

1. Two rows of forest exchange.

2. Two columns of forest exchange.

Fortunately, two rows(columns) can exchange only if both of them contain fruits or none of them contain fruits.

Your superior attach importance to these magical fruit, he needs to know this forest information at any time, and you as his best programmer, you need to write a program in order to ask his answers quick every time.

Input

The input consists of multiple test cases.

The first line has one integer W. Indicates the case number.(1<=W<=5)

For each case, the first line has three integers N, M, K. Indicates that the forest can be seen as maps N rows, M columns, there are K fruits on the map.(1<=N, M<=2*10^9, 0<=K<=10^5)

The next K lines, each line has three integers X, Y, C, indicates that there is a fruit with C energy in X row, Y column. (0<=X<=N-1, 0<=Y<=M-1, 1<=C<=1000)

The next line has one integer T. (0<=T<=10^5)

The next T lines, each line has three integers Q, A, B.

If Q = 1 indicates that this is a map of the row switching operation, the A row and B row exchange.

If Q = 2 indicates that this is a map of the column switching operation, the A column and B column exchange.

If Q = 3 means that it is time to ask your boss for the map, asked about the situation in (A, B).

(Ensure that all given A, B are legal. )

Output

For each case, you should output "Case #C:" first, where C indicates the case number and counts from 1.

In each case, for every time the boss asked, output an integer X, if asked point have fruit, then the output is the energy of the fruit, otherwise the output is 0.

Sample Input

1
3 3 2
1 1 1
2 2 2
5
3 1 1
1 1 2
2 1 2
3 1 1
3 2 2

Sample Output

Case #1:
1
2
1

Hint

No two fruits at the same location.

题意:有一个n*m的森林,里面有k个果实,每个果实的位置为(Xi,Yi),能量为Ci。

接下来有T次操作,每次操作输入Q  A    B,Q=1时交换A、B两行;Q=2时交换A、B两列;Q=3时,输出(A,B)位置的值,如果此处没有果实,输出0。

分析:由于n和m很大,而k很小,所以可以用map离散化。每次交换行或者列的时候只需交换map映射的值即可。

记录每个果实的值时,可以用双重map来记录,也可以将map与pair结合起来记录,还可以用结构体数组来记录果实的信息,只是没有前两种方便。

一、双重map

#include<cstdio>
#include<map>
using namespace std;
map<int, int> mr, mc;
map<int, map<int, int> > mp;
int main()
{
    int T, n, m, k, cas = 0;
    scanf("%d",&T);
    while(T--) {
        mr.clear();
        mc.clear();
        mp.clear();
        scanf("%d%d%d",&n,&m,&k);
        int a, b, c;
        int p = 0, q = 0;
        for(int i = 0; i < k; i++) {
            scanf("%d%d%d",&a, &b, &c);
            if(!mr[a])
                mr[a] = ++p;
            if(!mc[b])
                mc[b] = ++q;
            mp[mr[a]][mc[b]] = c;
        }
        int Q, type;
        scanf("%d",&Q);
        printf("Case #%d:\n", ++cas);
        while(Q--) {
            scanf("%d%d%d",&type, &a, &b);
            if(type == 1) {
                int tmp = mr[a];
                mr[a] = mr[b];
                mr[b] = tmp;
            }
            else if(type == 2) {
                int tmp = mc[a];
                mc[a] = mc[b];
                mc[b] = tmp;
            }
            else {
                printf("%d\n", mp[mr[a]][mc[b]]);
            }
        }
    }
    return 0;
}

二、map与pair结合

#include<cstdio>
#include<map>
using namespace std;
map<int, int> mr, mc;
map<pair<int, int>, int> mp;
int main()
{
    int T, n, m, k, cas = 0;
    scanf("%d",&T);
    while(T--) {
        mr.clear();
        mc.clear();
        mp.clear();
        scanf("%d%d%d",&n,&m,&k);
        int a, b, c;
        int p = 0, q = 0;
        for(int i = 0; i < k; i++) {
            scanf("%d%d%d",&a, &b, &c);
            if(!mr[a])
                mr[a] = ++p;
            if(!mc[b])
                mc[b] = ++q;
            mp[make_pair(mr[a], mc[b])] = c;
        }
        int Q, type;
        scanf("%d",&Q);
        printf("Case #%d:\n", ++cas);
        while(Q--) {
            scanf("%d%d%d",&type, &a, &b);
            if(type == 1) {
                int tmp = mr[a];
                mr[a] = mr[b];
                mr[b] = tmp;
            }
            else if(type == 2) {
                int tmp = mc[a];
                mc[a] = mc[b];
                mc[b] = tmp;
            }
            else {
                printf("%d\n", mp[make_pair(mr[a], mc[b])]);
            }
        }
    }
    return 0;
}

三、借助结构体数组和vector来求解

#include<cstdio>
#include<cstring>
#include<vector>
#include<map>
using namespace std;
const int N = 1e5 + 10;
struct node
{
    int y;
    int c;
} p[N];
vector <node> vr[N];
map<int, int> mp1, mp2;
int n, m, k;
int main()
{
    int T, Q;
    scanf("%d",&T);
    int cnt = 0;
    while(T--) {
        mp1.clear();
        mp2.clear();
        memset(vr, 0, sizeof(vr));
        printf("Case #%d:\n", ++cnt);
        scanf("%d%d%d", &n, &m, &k);
        int l = 0, r = 0;
        for(int i = 0; i < k; i++) {
            int a, b, c;
            scanf("%d%d%d",&a,&b,&c);
            if(mp1[a] == 0)
                mp1[a] = l++;
            if(mp2[b] == 0)
                mp2[b] = r++;
            p[i].y = mp2[b];
            p[i].c = c;
            vr[mp1[a]].push_back(p[i]);
        }
        scanf("%d",&Q);
        int t, x, y;
        while(Q--) {
            scanf("%d%d%d",&t, &x, &y);
            if(t == 1) {
                int a = mp1[x];
                int b = mp1[y];
                mp1[x] = b;
                mp1[y] = a;
            }
            if(t == 2) {
                int a = mp2[x];
                int b = mp2[y];
                mp2[x] = b;
                mp2[y] = a;
            }
            if(t == 3) {
                int a = mp1[x];
                int b = mp2[y];
                int flag = 0;
                for(int i = 0; i < vr[a].size(); i++) {
                    if(vr[a][i].y == b) {
                        flag = 1;
                        printf("%d\n", vr[a][i].c);
                        break;
                    }
                }
                if(!flag)
                    printf("0\n");
            }
        }
    }
    return 0;
}

hdu 4941 Magical Forest(STL之map应用)2014多校训练第7场

时间: 2024-10-14 07:19:03

hdu 4941 Magical Forest(STL之map应用)2014多校训练第7场的相关文章

HDU 4941 Magical Forest STL

这明明就是给纯C选手的大杀器啊. 题意:给你k坐标,表示 X,Y 有值C,有 3种操作 1) 交换A,B两行 2) 交换A,B两列 3) 询问(A,B)的值 解题思路:map离散化 解题代码: // File Name: 1007.cpp // Author: darkdream // Created Time: 2014年08月12日 星期二 21时05分18秒 #include<vector> #include<list> #include<map> #includ

hdu 4939 Stupid Tower Defense(DP)2014多校训练第7场

Stupid Tower Defense                                                                         Time Limit: 12000/6000 MS (Java/Others)    Memory Limit: 131072/131072 K (Java/Others) Problem Description FSF is addicted to a stupid tower defense game. Th

hdu 4970 Killing Monsters(简单题) 2014多校训练第9场

Killing Monsters                                                                        Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 131072/131072 K (Java/Others) Problem Description Kingdom Rush is a popular TD game, in which you should b

hdu 4923 Room and Moor(数学题)2014多校训练第6场

Room and Moor                                                                          Time Limit: 12000/6000 MS (Java/Others)    Memory Limit: 262144/262144 K (Java/Others) Problem Description PM Room defines a sequence A = {A1, A2,..., AN}, each of

hdu 4960 Another OCD Patient(dp)2014多校训练第9场

Another OCD Patient                                                                         Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 131072/131072 K (Java/Others) Problem Description Xiaoji is an OCD (obsessive-compulsive disorder) pat

HDU 4941 Magical Forest --STL Map应用

题意: 有n*m个格子(n,m <= 2*10^9),有k(k<=10^5)个格子中有值,现在有三种操作,第一种为交换两行,第二种为交换两列,交换时只有两行或两列都有格子有值或都没有格子有值时才能交换,第三种操作是询问现在第A行第B列值为多少. 解法:格子太大,但是k比较小,所以考虑离散一下,把行离散出来,最多10^5行,列用map存下即可. nowR[i] = j 时表示现在的第 i 行是原来的第 j 行, nowC表示列的 R[]表示该行有没有值, CntC[]表示列 然后交换时直交换上面

hdu 4941 Magical Forest(STL map &amp; 结构体运用)

题目链接:http://acm.hdu.edu.cn/showproblem.php?pid=4941 Magical Forest Time Limit: 24000/12000 MS (Java/Others)    Memory Limit: 131072/131072 K (Java/Others) Total Submission(s): 220    Accepted Submission(s): 105 Problem Description There is a forest c

STL : map函数的运用 --- hdu 4941 : Magical Forest

Magical Forest Time Limit: 24000/12000 MS (Java/Others)    Memory Limit: 131072/131072 K (Java/Others)Total Submission(s): 724    Accepted Submission(s): 343 Problem Description There is a forest can be seen as N * M grid. In this forest, there is so

hdu 4941 Magical Forest (map容器)

Magical Forest Time Limit: 24000/12000 MS (Java/Others)    Memory Limit: 131072/131072 K (Java/Others) Total Submission(s): 135    Accepted Submission(s): 69 Problem Description There is a forest can be seen as N * M grid. In this forest, there is so